# PHTTPClientDigestAuthentication Class Reference

`#include <http.h>`

Inheritance diagram for PHTTPClientDigestAuthentication:

List of all members.

## Public Types

| Algorithm_MD5
| NumAlgorithms
enum | Algorithm { Algorithm_MD5, NumAlgorithms }

## Public Member Functions

| PHTTPClientDigestAuthentication ()
PHTTPClientDigestAuthentication & | operator= (const PHTTPClientDigestAuthentication &auth)
virtual Comparison | Compare (const PObject &other) const
| Compare the two objects and return their relative rank.
virtual PBoolean | Parse (const PString &auth, PBoolean proxy)
virtual PBoolean | Authorise (AuthObject &pdu) const
virtual PString | GetAuthRealm () const
virtual void | SetAuthRealm (const PString &r)
const PString & | GetNonce () const
Algorithm | GetAlgorithm () const
const PString & | GetOpaque () const
bool | GetStale () const

## Protected Attributes

PString | authRealm
PString | nonce
Algorithm | algorithm
PString | opaque
bool | qopAuth
bool | qopAuthInt
bool | stale
PString | cnonce
PAtomicInteger | nonceCount

## Member Enumeration Documentation

enum PHTTPClientDigestAuthentication::Algorithm

Enumerator:

  Algorithm_MD5 |
  NumAlgorithms |

## Constructor & Destructor Documentation

PHTTPClientDigestAuthentication::PHTTPClientDigestAuthentication | ( |  | ) |

## Member Function Documentation

virtual PBoolean PHTTPClientDigestAuthentication::Authorise | ( | AuthObject & | pdu | ) | const`[virtual]`

virtual Comparison PHTTPClientDigestAuthentication::Compare | ( | const PObject & | other | ) | const`[virtual]`

Compare the two objects and return their relative rank.

This function is usually overridden by descendent classes to yield the ranking according to the semantics of the object.

The default function is to use the `CompareObjectMemoryDirect()` function to do a byte wise memory comparison of the two objects.

Returns:
  `LessThan`, `EqualTo` or `GreaterThan` according to the relative rank of the objects.

Reimplemented from PHTTPClientAuthentication.

Algorithm PHTTPClientDigestAuthentication::GetAlgorithm | ( |  | ) | const`[inline]`

virtual PString PHTTPClientDigestAuthentication::GetAuthRealm | ( |  | ) | const`[inline, virtual]`

Reimplemented from PHTTPClientAuthentication.

const PString& PHTTPClientDigestAuthentication::GetNonce | ( |  | ) | const`[inline]`

const PString& PHTTPClientDigestAuthentication::GetOpaque | ( |  | ) | const`[inline]`

bool PHTTPClientDigestAuthentication::GetStale | ( |  | ) | const`[inline]`

PHTTPClientDigestAuthentication& PHTTPClientDigestAuthentication::operator= | ( | const PHTTPClientDigestAuthentication & | auth | ) |

virtual PBoolean PHTTPClientDigestAuthentication::Parse | ( | const PString & | auth,
|  | PBoolean | proxy |
| ) |  |  | `[virtual]`

Implements PHTTPClientAuthentication.

virtual void PHTTPClientDigestAuthentication::SetAuthRealm | ( | const PString & | r | ) | `[inline, virtual]`

Reimplemented from PHTTPClientAuthentication.

## Member Data Documentation

Algorithm PHTTPClientDigestAuthentication::algorithm `[protected]`

PString PHTTPClientDigestAuthentication::authRealm `[protected]`

PString PHTTPClientDigestAuthentication::cnonce `[protected]`

PString PHTTPClientDigestAuthentication::nonce `[protected]`

PAtomicInteger PHTTPClientDigestAuthentication::nonceCount `[mutable, protected]`

PString PHTTPClientDigestAuthentication::opaque `[protected]`

bool PHTTPClientDigestAuthentication::qopAuth `[protected]`

bool PHTTPClientDigestAuthentication::qopAuthInt `[protected]`

bool PHTTPClientDigestAuthentication::stale `[protected]`

The documentation for this class was generated from the following file:

- http.h